﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace pr154_1
{
    // Абстрактный класс: 
    abstract class Base {
        // Защищенное целочисленное поле: 
        protected int num;
        // Конструктор: 
        public Base(int n) {
            // Вызов метода: 
            set(n);
        }
        // Абстрактные методы: 
        public abstract void show(); 
        public abstract void set(int n); 
        public abstract int get();
    }

    // Производный класс на основе абстрактного класса: 
    class Alpha: Base {
        // Защищенное целочисленное поле: 
        protected int val;
        // Конструктор:
        public Alpha(int n): base(n) {
            // Вызов метода: 
            show();
        }
        // Переопределение абстрактного метода: 
        public override void show() {
            // Отображение сообщения:
            Console.WriteLine("Alpha: {0}, {1} и {2}", num, val, get());
        }
        // Переопределение абстрактного метода: 
        public override void set(int n) {
            // Присваивание значений полям:
            num = n;
            val = n % 10;
        }
        // Переопределение абстрактного метода: 
        public override int get() { 
            return num / 10;
        }
    }

    // Производный класс на основе абстрактного класса: 
    class Bravo: Base {
        // Защищенное целочисленное поле: 
        protected int val;
        // Конструктор:
        public Bravo(int n): base(n) {
            // Вызов метода: 
            show();
        }
        // Переопределение абстрактного метода: 
        public override void show() {
            // Отображение сообщения:
            Console.WriteLine("Bravo: {0}, {1} и {2}", num, val, get());
        }
        // Переопределение абстрактного метода: 
        public override void set(int n) {
            // Присваивание значений полям:
            num = n;
            val = n % 100;
        }
        // Переопределение абстрактного метода: 
        public override int get() { 
            return num / 100;
        }
    }

    // Класс с главным методом: 
    class Program
    {
        // Главный метод:
        static void Main()
        {
            // Объектная переменная абстрактного класса:
            Base obj;
            // Создание объектов производных классов:
            Alpha A = new Alpha(123);
            Bravo B = new Bravo(321);
            // Объектной переменной базового класса присваивается
            // ссылка на объект производного класса:
            obj = A;
            Console.WriteLine("После выполнения команды obj = A");
            // Вызов методов через объектную переменную
            // базового класса:
            obj.set(456);
            obj.show();
            // Объектной переменной базового класса присваивается
            // ссылка на объект производного класса:
            obj = B;
            Console.WriteLine("После выполнения команды obj = B");
            // Вызов методов через объектную переменную
            // базового класса:
            obj.set(654);
            obj.show();
            // Задержка:
            Console.ReadLine();
        }
    }
}
